--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.393924923 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.405774308 +0100
@@ -9776,21 +11036,382 @@
 	 * finish.
 	 */
 	(void) ddi_dma_sync(dma_hdl, 0, 0, DDI_DMA_SYNC_FORDEV);
-	request_desc_low = (cmd->cmd_slot << 16) + desc_type;
+	request_desc |= ((cmd->cmd_slot << 16) | desc_type);
 	cmd->cmd_rfm = NULL;
-	MPTSAS_START_CMD(mpt, request_desc_low, request_desc_high);
+	MPTSAS_START_CMD(mpt, request_desc);
 	if ((mptsas_check_dma_handle(dma_hdl) != DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(acc_hdl) != DDI_SUCCESS)) {
 		ddi_fm_service_impact(mpt->m_dip, DDI_SERVICE_UNAFFECTED);
 	}
 }
 
+typedef void (mps_pre_f)(mptsas_t *, mptsas_pt_request_t *);
+static mps_pre_f	mpi_pre_ioc_facts;
+static mps_pre_f	mpi_pre_port_facts;
+static mps_pre_f	mpi_pre_fw_download;
+static mps_pre_f	mpi_pre_fw_25_download;
+static mps_pre_f	mpi_pre_fw_upload;
+static mps_pre_f	mpi_pre_fw_25_upload;
+static mps_pre_f	mpi_pre_sata_passthrough;
+static mps_pre_f	mpi_pre_smp_passthrough;
+static mps_pre_f	mpi_pre_config;
+static mps_pre_f	mpi_pre_sas_io_unit_control;
+static mps_pre_f	mpi_pre_scsi_io_req;
+
+/*
+ * Prepare the pt for a SAS2 FW_DOWNLOAD request.
+ */
+static void
+mpi_pre_fw_download(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+	pMpi2FWDownloadTCSGE_t tcsge;
+	pMpi2FWDownloadRequest req;
+
+	/*
+	 * If SAS3, call separate function.
+	 */
+	if (mpt->m_MPI25) {
+		mpi_pre_fw_25_download(mpt, pt);
+		return;
+	}
+
+	/*
+	 * User requests should come in with the Transaction
+	 * context element where the SGL will go. Putting the
+	 * SGL after that seems to work, but don't really know
+	 * why. Other drivers tend to create an extra SGL and
+	 * refer to the TCE through that.
+	 */
+	req = (pMpi2FWDownloadRequest)pt->request;
+	tcsge = (pMpi2FWDownloadTCSGE_t)&req->SGL;
+	if (tcsge->ContextSize != 0 || tcsge->DetailsLength != 12 ||
+	    tcsge->Flags != MPI2_SGE_FLAGS_TRANSACTION_ELEMENT) {
+		mptsas_log(mpt, CE_WARN, "FW Download tce invalid!");
+	}
+
+	pt->sgl_offset = offsetof(MPI2_FW_DOWNLOAD_REQUEST, SGL) +
+	    sizeof (*tcsge);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_fw_download(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    (int)pt->request_size, (int)pt->sgl_offset,
+		    (int)pt->dataout_size));
+	if (pt->data_size < sizeof (MPI2_FW_DOWNLOAD_REPLY))
+		NDBG15(("mpi_pre_fw_download(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_FW_DOWNLOAD_REPLY)));
+}
+
+/*
+ * Prepare the pt for a SAS3 FW_DOWNLOAD request.
+ */
+static void
+mpi_pre_fw_25_download(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+	pMpi2FWDownloadTCSGE_t tcsge;
+	pMpi2FWDownloadRequest req2;
+	pMpi25FWDownloadRequest req25;
+
+	/*
+	 * User requests should come in with the Transaction
+	 * context element where the SGL will go. The new firmware
+	 * Doesn't use TCE and has space in the main request for
+	 * this information. So move to the right place.
+	 */
+	req2 = (pMpi2FWDownloadRequest)pt->request;
+	req25 = (pMpi25FWDownloadRequest)pt->request;
+	tcsge = (pMpi2FWDownloadTCSGE_t)&req2->SGL;
+	if (tcsge->ContextSize != 0 || tcsge->DetailsLength != 12 ||
+	    tcsge->Flags != MPI2_SGE_FLAGS_TRANSACTION_ELEMENT) {
+		mptsas_log(mpt, CE_WARN, "FW Download tce invalid!");
+	}
+	req25->ImageOffset = tcsge->ImageOffset;
+	req25->ImageSize = tcsge->ImageSize;
+
+	pt->sgl_offset = offsetof(MPI25_FW_DOWNLOAD_REQUEST, SGL);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_fw_25_download(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    pt->request_size, pt->sgl_offset,
+		    pt->dataout_size));
+	if (pt->data_size < sizeof (MPI2_FW_DOWNLOAD_REPLY))
+		NDBG15(("mpi_pre_fw_25_download(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_FW_UPLOAD_REPLY)));
+}
+
+/*
+ * Prepare the pt for a SAS2 FW_UPLOAD request.
+ */
+static void
+mpi_pre_fw_upload(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+	pMpi2FWUploadTCSGE_t tcsge;
+	pMpi2FWUploadRequest_t req;
+
+	/*
+	 * If SAS3, call separate function.
+	 */
+	if (mpt->m_MPI25) {
+		mpi_pre_fw_25_upload(mpt, pt);
+		return;
+	}
+
+	/*
+	 * User requests should come in with the Transaction
+	 * context element where the SGL will go. Putting the
+	 * SGL after that seems to work, but don't really know
+	 * why. Other drivers tend to create an extra SGL and
+	 * refer to the TCE through that.
+	 */
+	req = (pMpi2FWUploadRequest_t)pt->request;
+	tcsge = (pMpi2FWUploadTCSGE_t)&req->SGL;
+	if (tcsge->ContextSize != 0 || tcsge->DetailsLength != 12 ||
+	    tcsge->Flags != MPI2_SGE_FLAGS_TRANSACTION_ELEMENT) {
+		mptsas_log(mpt, CE_WARN, "FW Upload tce invalid!");
+	}
+
+	pt->sgl_offset = offsetof(MPI2_FW_UPLOAD_REQUEST, SGL) +
+	    sizeof (*tcsge);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_fw_upload(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    pt->request_size, pt->sgl_offset,
+		    pt->dataout_size));
+	if (pt->data_size < sizeof (MPI2_FW_UPLOAD_REPLY))
+		NDBG15(("mpi_pre_fw_upload(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_FW_UPLOAD_REPLY)));
+}
+
+/*
+ * Prepare the pt a SAS3 FW_UPLOAD request.
+ */
+static void
+mpi_pre_fw_25_upload(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+	pMpi2FWUploadTCSGE_t tcsge;
+	pMpi2FWUploadRequest_t req2;
+	pMpi25FWUploadRequest_t req25;
+
+	/*
+	 * User requests should come in with the Transaction
+	 * context element where the SGL will go. The new firmware
+	 * Doesn't use TCE and has space in the main request for
+	 * this information. So move to the right place.
+	 */
+	req2 = (pMpi2FWUploadRequest_t)pt->request;
+	req25 = (pMpi25FWUploadRequest_t)pt->request;
+	tcsge = (pMpi2FWUploadTCSGE_t)&req2->SGL;
+	if (tcsge->ContextSize != 0 || tcsge->DetailsLength != 12 ||
+	    tcsge->Flags != MPI2_SGE_FLAGS_TRANSACTION_ELEMENT) {
+		mptsas_log(mpt, CE_WARN, "FW Upload tce invalid!");
+	}
+	req25->ImageOffset = tcsge->ImageOffset;
+	req25->ImageSize = tcsge->ImageSize;
+
+	pt->sgl_offset = offsetof(MPI25_FW_UPLOAD_REQUEST, SGL);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_fw_25_upload(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    pt->request_size, pt->sgl_offset,
+		    pt->dataout_size));
+	if (pt->data_size < sizeof (MPI2_FW_UPLOAD_REPLY))
+		NDBG15(("mpi_pre_fw_25_upload(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_FW_UPLOAD_REPLY)));
+}
+
+/*
+ * Prepare the pt for an IOC_FACTS request.
+ */
+static void
+mpi_pre_ioc_facts(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+#ifndef __lock_lint
+	_NOTE(ARGUNUSED(mpt))
+#endif
+	if (pt->request_size != sizeof (MPI2_IOC_FACTS_REQUEST))
+		NDBG15(("mpi_pre_ioc_facts(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    pt->request_size,
+		    (int)sizeof (MPI2_IOC_FACTS_REQUEST),
+		    pt->dataout_size));
+	if (pt->data_size != sizeof (MPI2_IOC_FACTS_REPLY))
+		NDBG15(("mpi_pre_ioc_facts(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_IOC_FACTS_REPLY)));
+	pt->sgl_offset = (uint16_t)pt->request_size;
+}
+
+/*
+ * Prepare the pt for a PORT_FACTS request.
+ */
+static void
+mpi_pre_port_facts(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+#ifndef __lock_lint
+	_NOTE(ARGUNUSED(mpt))
+#endif
+	if (pt->request_size != sizeof (MPI2_PORT_FACTS_REQUEST))
+		NDBG15(("mpi_pre_port_facts(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    pt->request_size,
+		    (int)sizeof (MPI2_PORT_FACTS_REQUEST),
+		    pt->dataout_size));
+	if (pt->data_size != sizeof (MPI2_PORT_FACTS_REPLY))
+		NDBG15(("mpi_pre_port_facts(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_PORT_FACTS_REPLY)));
+	pt->sgl_offset = (uint16_t)pt->request_size;
+}
+
+/*
+ * Prepare pt for a SATA_PASSTHROUGH request.
+ */
+static void
+mpi_pre_sata_passthrough(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+#ifndef __lock_lint
+	_NOTE(ARGUNUSED(mpt))
+#endif
+	pt->sgl_offset = offsetof(MPI2_SATA_PASSTHROUGH_REQUEST, SGL);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_sata_passthrough(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    pt->request_size, pt->sgl_offset,
+		    pt->dataout_size));
+	if (pt->data_size != sizeof (MPI2_SATA_PASSTHROUGH_REPLY))
+		NDBG15(("mpi_pre_sata_passthrough(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_SATA_PASSTHROUGH_REPLY)));
+}
+
+static void
+mpi_pre_smp_passthrough(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+#ifndef __lock_lint
+	_NOTE(ARGUNUSED(mpt))
+#endif
+	pt->sgl_offset = offsetof(MPI2_SMP_PASSTHROUGH_REQUEST, SGL);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_smp_passthrough(): Incorrect req size, "
+		    "0x%x, should be 0x%x, dataoutsz 0x%x",
+		    pt->request_size, pt->sgl_offset,
+		    pt->dataout_size));
+	if (pt->data_size != sizeof (MPI2_SMP_PASSTHROUGH_REPLY))
+		NDBG15(("mpi_pre_smp_passthrough(): Incorrect rep size, "
+		    "0x%x, should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_SMP_PASSTHROUGH_REPLY)));
+}
+
+/*
+ * Prepare pt for a CONFIG request.
+ */
+static void
+mpi_pre_config(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+#ifndef __lock_lint
+	_NOTE(ARGUNUSED(mpt))
+#endif
+	pt->sgl_offset = offsetof(MPI2_CONFIG_REQUEST, PageBufferSGE);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_config(): Incorrect req size, 0x%x, "
+		    "should be 0x%x, dataoutsz 0x%x", pt->request_size,
+		    pt->sgl_offset, pt->dataout_size));
+	if (pt->data_size != sizeof (MPI2_CONFIG_REPLY))
+		NDBG15(("mpi_pre_config(): Incorrect rep size, 0x%x, "
+		    "should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_CONFIG_REPLY)));
+	pt->simple = 1;
+}
+
+/*
+ * Prepare pt for a SCSI_IO_REQ request.
+ */
+static void
+mpi_pre_scsi_io_req(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+#ifndef __lock_lint
+	_NOTE(ARGUNUSED(mpt))
+#endif
+	pt->sgl_offset = offsetof(MPI2_SCSI_IO_REQUEST, SGL);
+	if (pt->request_size != pt->sgl_offset)
+		NDBG15(("mpi_pre_config(): Incorrect req size, 0x%x, "
+		    "should be 0x%x, dataoutsz 0x%x", pt->request_size,
+		    pt->sgl_offset,
+		    pt->dataout_size));
+	if (pt->data_size != sizeof (MPI2_SCSI_IO_REPLY))
+		NDBG15(("mpi_pre_config(): Incorrect rep size, 0x%x, "
+		    "should be 0x%x", pt->data_size,
+		    (int)sizeof (MPI2_SCSI_IO_REPLY)));
+}
+
+/*
+ * Prepare the mps_command for a SAS_IO_UNIT_CONTROL request.
+ */
+static void
+mpi_pre_sas_io_unit_control(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+#ifndef __lock_lint
+	_NOTE(ARGUNUSED(mpt))
+#endif
+	pt->sgl_offset = (uint16_t)pt->request_size;
+}
+
+/*
+ * A set of functions to prepare an mps_command for the various
+ * supported requests.
+ */
+struct mps_func {
+	U8		Function;
+	char		*Name;
+	mps_pre_f	*f_pre;
+} mps_func_list[] = {
+	{ MPI2_FUNCTION_IOC_FACTS, "IOC_FACTS",		mpi_pre_ioc_facts },
+	{ MPI2_FUNCTION_PORT_FACTS, "PORT_FACTS",	mpi_pre_port_facts },
+	{ MPI2_FUNCTION_FW_DOWNLOAD, "FW_DOWNLOAD",	mpi_pre_fw_download },
+	{ MPI2_FUNCTION_FW_UPLOAD, "FW_UPLOAD",		mpi_pre_fw_upload },
+	{ MPI2_FUNCTION_SATA_PASSTHROUGH, "SATA_PASSTHROUGH",
+	    mpi_pre_sata_passthrough },
+	{ MPI2_FUNCTION_SMP_PASSTHROUGH, "SMP_PASSTHROUGH",
+	    mpi_pre_smp_passthrough},
+	{ MPI2_FUNCTION_SCSI_IO_REQUEST, "SCSI_IO_REQUEST",
+	    mpi_pre_scsi_io_req},
+	{ MPI2_FUNCTION_CONFIG, "CONFIG",		mpi_pre_config},
+	{ MPI2_FUNCTION_SAS_IO_UNIT_CONTROL, "SAS_IO_UNIT_CONTROL",
+	    mpi_pre_sas_io_unit_control },
+	{ 0xFF, NULL,				NULL } /* list end */
+};
+
+static void
+mptsas_prep_sgl_offset(mptsas_t *mpt, mptsas_pt_request_t *pt)
+{
+	pMPI2RequestHeader_t	hdr;
+	struct mps_func		*f;
+
+	hdr = (pMPI2RequestHeader_t)pt->request;
+
+	for (f = mps_func_list; f->f_pre != NULL; f++) {
+		if (hdr->Function == f->Function) {
+			f->f_pre(mpt, pt);
+			NDBG15(("mptsas_prep_sgl_offset: Function %s,"
+			    " sgl_offset 0x%x", f->Name,
+			    pt->sgl_offset));
+			return;
+		}
+	}
+	NDBG15(("mptsas_prep_sgl_offset: Unknown Function 0x%02x,"
+	    " returning req_size 0x%x for sgl_offset",
+	    hdr->Function, pt->request_size));
+	pt->sgl_offset = (uint16_t)pt->request_size;
+}
 
 
 static int
 mptsas_do_passthru(mptsas_t *mpt, uint8_t *request, uint8_t *reply,
     uint8_t *data, uint32_t request_size, uint32_t reply_size,
-    uint32_t data_size, uint32_t direction, uint8_t *dataout,
+    uint32_t data_size, uint8_t direction, uint8_t *dataout,
     uint32_t dataout_size, short timeout, int mode)
 {
 	mptsas_pt_request_t		pt;
@@ -9867,6 +11488,8 @@
 			mutex_enter(&mpt->m_mutex);
 		}
 	}
+	else
+		bzero(&data_dma_state, sizeof (data_dma_state));
 
 	if (dataout_size != 0) {
 		dataout_dma_state.size = dataout_size;
@@ -9890,6 +11513,8 @@
 		}
 		mutex_enter(&mpt->m_mutex);
 	}
+	else
+		bzero(&dataout_dma_state, sizeof (dataout_dma_state));
 
 	if ((rvalue = (mptsas_request_from_pool(mpt, &cmd, &pkt))) == -1) {
 		status = EAGAIN;
@@ -9906,11 +11531,13 @@
 
 	pt.request = (uint8_t *)request_msg;
 	pt.direction = direction;
+	pt.simple = 0;
 	pt.request_size = request_size;
 	pt.data_size = data_size;
 	pt.dataout_size = dataout_size;
 	pt.data_cookie = data_dma_state.cookie;
 	pt.dataout_cookie = dataout_dma_state.cookie;
+	mptsas_prep_sgl_offset(mpt, &pt);
 
 	/*
 	 * Form a blank cmd/pkt to store the acknowledgement message
@@ -9967,7 +11594,7 @@
 		    DDI_DMA_SYNC_FORCPU);
 		reply_msg = (pMPI2DefaultReply_t)
 		    (mpt->m_reply_frame + (cmd->cmd_rfm -
-		    mpt->m_reply_frame_dma_addr));
+		    (mpt->m_reply_frame_dma_addr&0xfffffffful)));
 	}
 
 	mptsas_fma_check(mpt, cmd);
@@ -10123,7 +11750,7 @@
 		    (uint8_t *)((uintptr_t)data->PtrReply),
 		    (uint8_t *)((uintptr_t)data->PtrData),
 		    data->RequestSize, data->ReplySize,
-		    data->DataSize, data->DataDirection,
+		    data->DataSize, (uint8_t)data->DataDirection,
 		    (uint8_t *)((uintptr_t)data->PtrDataOut),
 		    data->DataOutSize, data->Timeout, mode));
 	} else {
@@ -10152,7 +11779,8 @@
 	pMpi2DiagReleaseRequest_t	pDiag_release_msg;
 	struct scsi_pkt			*pkt = cmd->cmd_pkt;
 	mptsas_diag_request_t		*diag = pkt->pkt_ha_private;
-	uint32_t			request_desc_low, i;
+	uint32_t			i;
+	uint64_t			request_desc;
 
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
@@ -10205,10 +11833,10 @@
 	 */
 	(void) ddi_dma_sync(mpt->m_dma_req_frame_hdl, 0, 0,
 	    DDI_DMA_SYNC_FORDEV);
-	request_desc_low = (cmd->cmd_slot << 16) +
+	request_desc = (cmd->cmd_slot << 16) |
 	    MPI2_REQ_DESCRIPT_FLAGS_DEFAULT_TYPE;
 	cmd->cmd_rfm = NULL;
-	MPTSAS_START_CMD(mpt, request_desc_low, 0);
+	MPTSAS_START_CMD(mpt, request_desc);
 	if ((mptsas_check_dma_handle(mpt->m_dma_req_frame_hdl) !=
 	    DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_req_frame_hdl) !=
@@ -10306,7 +11934,8 @@
 		(void) ddi_dma_sync(mpt->m_dma_reply_frame_hdl, 0, 0,
 		    DDI_DMA_SYNC_FORCPU);
 		reply = (pMpi2DiagBufferPostReply_t)(mpt->m_reply_frame +
-		    (cmd->cmd_rfm - mpt->m_reply_frame_dma_addr));
+		    (cmd->cmd_rfm -
+		    (mpt->m_reply_frame_dma_addr&0xfffffffful)));
 
 		/*
 		 * Get the reply message data
@@ -10460,7 +12089,8 @@
 		(void) ddi_dma_sync(mpt->m_dma_reply_frame_hdl, 0, 0,
 		    DDI_DMA_SYNC_FORCPU);
 		reply = (pMpi2DiagReleaseReply_t)(mpt->m_reply_frame +
-		    (cmd->cmd_rfm - mpt->m_reply_frame_dma_addr));
+		    (cmd->cmd_rfm -
+		    (mpt->m_reply_frame_dma_addr&0xfffffffful)));
 
 		/*
 		 * Get the reply message data
@@ -11208,7 +12838,7 @@
 	char	*driver_verstr = MPTSAS_MOD_STRING;
 
 	mptsas_lookup_pci_data(mpt, adapter_data);
-	adapter_data->AdapterType = MPTIOCTL_ADAPTER_TYPE_SAS2;
+	adapter_data->AdapterType = MPTIOCTL_ADAPTER_TYPE_SAS3;
 	adapter_data->PCIDeviceHwId = (uint32_t)mpt->m_devid;
 	adapter_data->PCIDeviceHwRev = (uint32_t)mpt->m_revid;
 	adapter_data->SubSystemId = (uint32_t)mpt->m_ssid;
@@ -11482,7 +13112,7 @@
 		return (EPERM);
 	}
 
-	mpt = ddi_get_soft_state(mptsas_state, MINOR2INST(getminor(dev)));
+	mpt = ddi_get_soft_state(mptsas3_state, MINOR2INST(getminor(dev)));
 	if (mpt == NULL) {
 		/*
 		 * Called from iport node, get the states
@@ -11503,7 +13133,7 @@
 			if (pm_raise_power(mpt->m_dip, 0, PM_LEVEL_D0) !=
 			    DDI_SUCCESS) {
 				mptsas_log(mpt, CE_WARN,
-				    "mptsas%d: mptsas_ioctl: Raise power "
+				    "mptsas3%d: mptsas_ioctl: Raise power "
 				    "request failed.", mpt->m_instance);
 				(void) pm_idle_component(mpt->m_dip, 0);
 				return (ENXIO);
@@ -11743,7 +13373,7 @@
 	 */
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
-		mptsas_set_throttle(mpt, ptgt, HOLD_THROTTLE);
+		mptsas_set_throttle_mtx(mpt, ptgt, HOLD_THROTTLE);
 	}
 
 	/*
@@ -11781,7 +13411,7 @@
 	 */
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
-		mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
+		mptsas_set_throttle_mtx(mpt, ptgt, MAX_THROTTLE);
 	}
 
 	mptsas_doneq_empty(mpt);
@@ -11804,7 +13434,8 @@
 mptsas_init_chip(mptsas_t *mpt, int first_time)
 {
 	ddi_dma_cookie_t	cookie;
-	uint32_t		i;
+	mptsas_reply_pqueue_t	*rpqp;
+	uint32_t		i, j;
 	int			rval;
 
 	/*
@@ -11847,6 +13478,16 @@
 		goto fail;
 	}
 
+	/*
+	 * Now we know chip MSIX capabilitites and it's not been done
+	 * previously register interrupts accordingly. Need to know this
+	 * information before allocating the reply frames below.
+	 */
+	if (mpt->m_intr_cnt == 0) {
+		if (mptsas_register_intrs(mpt) == FALSE)
+			goto fail;
+	}
+
 	mpt->m_targets = refhash_create(MPTSAS_TARGET_BUCKET_COUNT,
 	    mptsas_target_addr_hash, mptsas_target_addr_cmp,
 	    mptsas_target_free, sizeof (mptsas_target_t),
@@ -11864,6 +13505,10 @@
 		mptsas_log(mpt, CE_WARN, "mptsas_alloc_request_frames failed");
 		goto fail;
 	}
+	if (mptsas_alloc_sense_bufs(mpt) == DDI_FAILURE) {
+		mptsas_log(mpt, CE_WARN, "mptsas_alloc_sense_bufs failed");
+		goto fail;
+	}
 	if (mptsas_alloc_free_queue(mpt) == DDI_FAILURE) {
 		mptsas_log(mpt, CE_WARN, "mptsas_alloc_free_queue failed!");
 		goto fail;
@@ -11889,16 +13534,10 @@
 	mptsas_alloc_reply_args(mpt);
 
 	/*
-	 * Initialize reply post index.  Reply free index is initialized after
-	 * the next loop.
-	 */
-	mpt->m_post_index = 0;
-
-	/*
 	 * Initialize the Reply Free Queue with the physical addresses of our
 	 * reply frames.
 	 */
-	cookie.dmac_address = mpt->m_reply_frame_dma_addr;
+	cookie.dmac_address = mpt->m_reply_frame_dma_addr&0xfffffffful;
 	for (i = 0; i < mpt->m_max_replies; i++) {
 		ddi_put32(mpt->m_acc_free_queue_hdl,
 		    &((uint32_t *)(void *)mpt->m_free_queue)[i],
@@ -11916,17 +13555,31 @@
 	ddi_put32(mpt->m_datap, &mpt->m_reg->ReplyFreeHostIndex, i);
 
 	/*
-	 * Initialize the reply post queue to 0xFFFFFFFF,0xFFFFFFFF's.
+	 * Initialize the reply post queue to 0xFFFFFFFF,0xFFFFFFFF's
+	 * and the indexes to 0.
 	 */
-	for (i = 0; i < mpt->m_post_queue_depth; i++) {
-		ddi_put64(mpt->m_acc_post_queue_hdl,
-		    &((uint64_t *)(void *)mpt->m_post_queue)[i],
-		    0xFFFFFFFFFFFFFFFF);
+	rpqp = mpt->m_rep_post_queues;
+	for (j = 0; j < mpt->m_post_reply_qcount; j++) {
+		for (i = 0; i < mpt->m_post_queue_depth; i++) {
+			ddi_put64(mpt->m_acc_post_queue_hdl,
+			    &((uint64_t *)(void *)rpqp->rpq_queue)[i],
+			    0xFFFFFFFFFFFFFFFF);
+		}
+		rpqp->rpq_index = 0;
+		rpqp++;
 	}
 	(void) ddi_dma_sync(mpt->m_dma_post_queue_hdl, 0, 0,
 	    DDI_DMA_SYNC_FORDEV);
 
 	/*
+	 * Initialise all the reply post queue indexes.
+	 */
+	for (j = 0; j < mpt->m_post_reply_qcount; j++) {
+		ddi_put32(mpt->m_datap, &mpt->m_reg->ReplyPostHostIndex,
+		    j << MPI2_RPHI_MSIX_INDEX_SHIFT);
+	}
+
+	/*
 	 * Enable ports
 	 */
 	if (mptsas_ioc_enable_port(mpt) == DDI_FAILURE) {
@@ -11938,6 +13591,8 @@
 	 * enable events
 	 */
 	if (mptsas_ioc_enable_event_notification(mpt)) {
+		mptsas_log(mpt, CE_WARN,
+		    "mptsas_ioc_enable_event_notification failed");
 		goto fail;
 	}
 
@@ -11948,6 +13603,8 @@
 
 	if ((mptsas_check_dma_handle(mpt->m_dma_req_frame_hdl) !=
 	    DDI_SUCCESS) ||
+	    (mptsas_check_dma_handle(mpt->m_dma_req_sense_hdl) !=
+	    DDI_SUCCESS) ||
 	    (mptsas_check_dma_handle(mpt->m_dma_reply_frame_hdl) !=
 	    DDI_SUCCESS) ||
 	    (mptsas_check_dma_handle(mpt->m_dma_free_queue_hdl) !=
@@ -11964,6 +13621,8 @@
 	if ((mptsas_check_acc_handle(mpt->m_datap) != DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_req_frame_hdl) !=
 	    DDI_SUCCESS) ||
+	    (mptsas_check_acc_handle(mpt->m_acc_req_sense_hdl) !=
+	    DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_reply_frame_hdl) !=
 	    DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_free_queue_hdl) !=
@@ -12032,26 +13691,36 @@
 		switch (cap) {
 			case PCI_CAP_ID_PM:
 				mptsas_log(mpt, CE_NOTE,
-				    "?mptsas%d supports power management.\n",
+				    "?mptsas3%d supports power management.\n",
 				    mpt->m_instance);
 				mpt->m_options |= MPTSAS_OPT_PM;
 
 				/* Save PMCSR offset */
 				mpt->m_pmcsr_offset = caps_ptr + PCI_PMCSR;
 				break;
+			case PCI_CAP_ID_MSI:
+				mptsas_log(mpt, CE_NOTE,
+				    "?mptsas3%d supports MSI.\n",
+				    mpt->m_instance);
+				mpt->m_options |= MPTSAS_OPT_MSI;
+				break;
+			case PCI_CAP_ID_MSI_X:
+				mptsas_log(mpt, CE_NOTE,
+				    "?mptsas3%d supports MSI-X.\n",
+				    mpt->m_instance);
+				mpt->m_options |= MPTSAS_OPT_MSI_X;
+				break;
 			/*
 			 * The following capabilities are valid.  Any others
 			 * will cause a message to be logged.
 			 */
 			case PCI_CAP_ID_VPD:
-			case PCI_CAP_ID_MSI:
 			case PCI_CAP_ID_PCIX:
 			case PCI_CAP_ID_PCI_E:
-			case PCI_CAP_ID_MSI_X:
 				break;
 			default:
 				mptsas_log(mpt, CE_NOTE,
-				    "?mptsas%d unrecognized capability "
+				    "?mptsas3%d unrecognized capability "
 				    "0x%x.\n", mpt->m_instance, cap);
 				break;
 		}
@@ -12077,9 +13746,6 @@
 			};
 	uint16_t	pmcsr_stat;
 
-	if (mptsas_get_pci_cap(mpt) == FALSE) {
-		return (DDI_FAILURE);
-	}
 	/*
 	 * If PCI's capability does not support PM, then don't need
 	 * to registe the pm-components
@@ -12090,13 +13756,13 @@
 	 * If power management is supported by this chip, create
 	 * pm-components property for the power management framework
 	 */
-	(void) sprintf(pmc_name, "NAME=mptsas%d", mpt->m_instance);
+	(void) sprintf(pmc_name, "NAME=mptsas3%d", mpt->m_instance);
 	pmc[0] = pmc_name;
 	if (ddi_prop_update_string_array(DDI_DEV_T_NONE, mpt->m_dip,
 	    "pm-components", pmc, 3) != DDI_PROP_SUCCESS) {
 		mpt->m_options &= ~MPTSAS_OPT_PM;
 		mptsas_log(mpt, CE_WARN,
-		    "mptsas%d: pm-component property creation failed.",
+		    "mptsas3%d: pm-component property creation failed.",
 		    mpt->m_instance);
 		return (DDI_FAILURE);
 	}
@@ -12108,7 +13774,7 @@
 	pmcsr_stat = pci_config_get16(mpt->m_config_handle,
 	    mpt->m_pmcsr_offset);
 	if ((pmcsr_stat & PCI_PMCSR_STATE_MASK) != PCI_PMCSR_D0) {
-		mptsas_log(mpt, CE_WARN, "mptsas%d: Power up the device",
+		mptsas_log(mpt, CE_WARN, "mptsas3%d: Power up the device",
 		    mpt->m_instance);
 		pci_config_put16(mpt->m_config_handle, mpt->m_pmcsr_offset,
 		    PCI_PMCSR_D0);
@@ -12145,22 +13811,33 @@
 	NDBG6(("ddi_intr_get_supported_types() returned: 0x%x", intr_types));
 
 	/*
+	 * Try MSIX first.
+	 */
+	if (mptsas_enable_msix && (intr_types & DDI_INTR_TYPE_MSIX)) {
+		if (mptsas_add_intrs(mpt, DDI_INTR_TYPE_MSIX) == DDI_SUCCESS) {
+			NDBG6(("Using MSI-X interrupt type"));
+			mpt->m_intr_type = DDI_INTR_TYPE_MSIX;
+			return (TRUE);
+		}
+	}
+
+	/*
 	 * Try MSI, but fall back to FIXED
 	 */
 	if (mptsas_enable_msi && (intr_types & DDI_INTR_TYPE_MSI)) {
 		if (mptsas_add_intrs(mpt, DDI_INTR_TYPE_MSI) == DDI_SUCCESS) {
-			NDBG0(("Using MSI interrupt type"));
+			NDBG6(("Using MSI interrupt type"));
 			mpt->m_intr_type = DDI_INTR_TYPE_MSI;
 			return (TRUE);
 		}
 	}
 	if (intr_types & DDI_INTR_TYPE_FIXED) {
 		if (mptsas_add_intrs(mpt, DDI_INTR_TYPE_FIXED) == DDI_SUCCESS) {
-			NDBG0(("Using FIXED interrupt type"));
+			NDBG6(("Using FIXED interrupt type"));
 			mpt->m_intr_type = DDI_INTR_TYPE_FIXED;
 			return (TRUE);
 		} else {
-			NDBG0(("FIXED interrupt registration failed"));
+			NDBG6(("FIXED interrupt registration failed"));
 			return (FALSE);
 		}
 	}
@@ -12197,7 +13874,7 @@
 		return (DDI_FAILURE);
 	}
 
-	/* Get number of available interrupts */
+	/* Get number of interrupts available to this device */
 	ret = ddi_intr_get_navail(dip, intr_type, &avail);
 	if ((ret != DDI_SUCCESS) || (avail == 0)) {
 		mptsas_log(mpt, CE_WARN, "ddi_intr_get_navail() failed, "
@@ -12206,25 +13883,47 @@
 		return (DDI_FAILURE);
 	}
 
-	if (avail < count) {
+	if (count < avail) {
 		mptsas_log(mpt, CE_NOTE, "ddi_intr_get_nvail returned %d, "
 		    "navail() returned %d", count, avail);
 	}
 
-	/* Mpt only have one interrupt routine */
-	if ((intr_type == DDI_INTR_TYPE_MSI) && (count > 1)) {
-		count = 1;
+	NDBG6(("mptsas_add_intrs:count %d, avail %d", count, avail));
+
+	if (intr_type == DDI_INTR_TYPE_MSIX) {
+		if (!mptsas3_max_msix_intrs) {
+			return (DDI_FAILURE);
+		}
+
+		/*
+		 * Restrict the number of interrupts, firstly by
+		 * the number returned from the IOCInfo, then by
+		 * overall restriction.
+		 */
+		if (avail > mpt->m_max_msix_vectors) {
+			avail = mpt->m_max_msix_vectors?
+			    mpt->m_max_msix_vectors:1;
+			NDBG6(("mptsas_add_intrs: mmmv avail %d", avail));
+		}
+		if (avail > mptsas3_max_msix_intrs) {
+			avail = mptsas3_max_msix_intrs;
+			NDBG6(("mptsas_add_intrs: m3mmi avail %d", avail));
+		}
+	}
+	if (intr_type == DDI_INTR_TYPE_MSI) {
+		NDBG6(("mptsas_add_intrs: MSI avail %d", avail));
+		avail = 1;
 	}
 
 	/* Allocate an array of interrupt handles */
-	mpt->m_intr_size = count * sizeof (ddi_intr_handle_t);
+	mpt->m_intr_size = avail * sizeof (ddi_intr_handle_t);
 	mpt->m_htable = kmem_alloc(mpt->m_intr_size, KM_SLEEP);
 
 	flag = DDI_INTR_ALLOC_NORMAL;
 
 	/* call ddi_intr_alloc() */
 	ret = ddi_intr_alloc(dip, mpt->m_htable, intr_type, 0,
-	    count, &actual, flag);
+	    avail, &actual, flag);
 
 	if ((ret != DDI_SUCCESS) || (actual == 0)) {
 		mptsas_log(mpt, CE_WARN, "ddi_intr_alloc() failed, ret %d\n",
@@ -12233,14 +13932,14 @@
 		return (DDI_FAILURE);
 	}
 
+	NDBG6(("mptsas_add_intrs: actual %d, avail %d", actual, avail));
 	/* use interrupt count returned or abort? */
-	if (actual < count) {
-		mptsas_log(mpt, CE_NOTE, "Requested: %d, Received: %d\n",
-		    count, actual);
+	if (actual < avail) {
+		mptsas_log(mpt, CE_NOTE,
+		    "Interrupts requested: %d, received: %d\n",
+		    avail, actual);
 	}
 
-	mpt->m_intr_cnt = actual;
-
 	/*
 	 * Get priority for first msi, assume remaining are all the same
 	 */
@@ -12301,6 +14000,8 @@
 		return (DDI_FAILURE);
 	}
 
+	mpt->m_intr_cnt = actual;
+
 	/*
 	 * Enable interrupts
 	 */
@@ -12313,6 +14014,22 @@
 			(void) ddi_intr_enable(mpt->m_htable[i]);
 		}
 	}
+
+	switch (intr_type) {
+	case DDI_INTR_TYPE_MSIX:
+		mptsas_log(mpt, CE_NOTE, "?Using %d MSI-X interrupt(s) "
+		    "(Available sys %d, mpt %d, Requested %d)\n",
+		    actual, count, mpt->m_max_msix_vectors, avail);
+		break;
+	case DDI_INTR_TYPE_MSI:
+		mptsas_log(mpt, CE_NOTE, "Using single MSI interrupt\n");
+		break;
+	case DDI_INTR_TYPE_FIXED:
+	default:
+		mptsas_log(mpt, CE_NOTE, "Using single fixed interrupt\n");
+		break;
+	}
+
 	return (DDI_SUCCESS);
 }
 
@@ -12343,8 +14060,8 @@
 		(void) ddi_intr_remove_handler(mpt->m_htable[i]);
 		(void) ddi_intr_free(mpt->m_htable[i]);
 	}
-
 	kmem_free(mpt->m_htable, mpt->m_intr_size);
+	mpt->m_intr_cnt = 0;
 }
 
 /*
@@ -12494,13 +14211,13 @@
 	uint64_t	devicename;
 	uint16_t	pdev_hdl;
 	mptsas_target_t	*tmp_tgt = NULL;
-	uint16_t	bay_num, enclosure;
+	uint16_t	bay_num, enclosure, io_flags;
 
 	ASSERT(*pptgt == NULL);
 
 	rval = mptsas_get_sas_device_page0(mpt, page_address, dev_handle,
 	    &sas_wwn, &dev_info, &physport, &phynum, &pdev_hdl,
-	    &bay_num, &enclosure);
+	    &bay_num, &enclosure, &io_flags);
 	if (rval != DDI_SUCCESS) {
 		rval = DEV_INFO_FAIL_PAGE0;
 		return (rval);
@@ -12545,7 +14262,9 @@
 		tmp_tgt->m_qfull_retry_interval =
 		    drv_usectohz(QFULL_RETRY_INTERVAL * 1000);
 		tmp_tgt->m_t_throttle = MAX_THROTTLE;
+		mutex_init(&tmp_tgt->m_t_mutex, NULL, MUTEX_DRIVER, NULL);
 		devicename = mptsas_get_sata_guid(mpt, tmp_tgt, 0);
+		mutex_destroy(&tmp_tgt->m_t_mutex);
 		kmem_free(tmp_tgt, sizeof (struct mptsas_target));
 		mutex_enter(&mpt->m_mutex);
 		if (devicename != 0 && (((devicename >> 56) & 0xf0) == 0x50)) {
@@ -12564,6 +14283,7 @@
 		rval = DEV_INFO_FAIL_ALLOC;
 		return (rval);
 	}
+	(*pptgt)->m_io_flags = io_flags;
 	(*pptgt)->m_enclosure = enclosure;
 	(*pptgt)->m_slot_num = bay_num;
 	return (DEV_INFO_SUCCESS);
@@ -12701,6 +14421,7 @@
 	}
 	bcopy(cdb, pktp->pkt_cdbp, cdblen);
 	pktp->pkt_flags = FLAG_NOPARITY;
+	pktp->pkt_time = mptsas_scsi_pkt_time;
 	if (scsi_poll(pktp) < 0) {
 		goto out;
 	}
@@ -13549,7 +15270,7 @@
  * because we didn't call mdi_pi_free for path
  */
 static int
-mptsas_offline_target(dev_info_t *pdip, char *name)
+mptsas_offline_targetdev(dev_info_t *pdip, char *name)
 {
 	dev_info_t		*child = NULL, *prechild = NULL;
 	mdi_pathinfo_t		*pip = NULL, *savepip = NULL;
@@ -13584,7 +15305,7 @@
 			if (ndi_prop_create_boolean(DDI_DEV_T_NONE,
 			    prechild, MPTSAS_DEV_GONE) !=
 			    DDI_PROP_SUCCESS) {
-				mptsas_log(mpt, CE_WARN, "mptsas driver "
+				mptsas_log(mpt, CE_WARN,
 				    "unable to create property for "
 				    "SAS %s (MPTSAS_DEV_GONE)", addr);
 			}
@@ -13961,8 +15682,7 @@
 	char			*old_guid = NULL;
 	mptsas_t		*mpt = DIP2MPT(pdip);
 	char			*lun_addr = NULL;
-	char			*wwn_str = NULL;
-	char			*attached_wwn_str = NULL;
+	char			wwn_str[MPTSAS_WWN_STRLEN];
 	char			*component = NULL;
 	uint8_t			phy = 0xFF;
 	uint64_t		sas_wwn;
@@ -13976,7 +15696,7 @@
 	uint8_t			physport;
 	uint8_t			phy_id;
 	uint32_t		page_address;
-	uint16_t		bay_num, enclosure;
+	uint16_t		bay_num, enclosure, io_flags;
 	char			pdev_wwn_str[MPTSAS_WWN_STRLEN];
 	uint32_t		dev_info;
 
@@ -14070,13 +15790,12 @@
 	 * if nodename can't be determined then print a message and skip it
 	 */
 	if (nodename == NULL) {
-		mptsas_log(mpt, CE_WARN, "mptsas driver found no compatible "
+		mptsas_log(mpt, CE_WARN, "found no compatible "
 		    "driver for target%d lun %d dtype:0x%02x", target, lun,
 		    inq->inq_dtype);
 		return (DDI_FAILURE);
 	}
 
-	wwn_str = kmem_zalloc(MPTSAS_WWN_STRLEN, KM_SLEEP);
 	/* The property is needed by MPAPI */
 	(void) sprintf(wwn_str, "%016"PRIx64, sas_wwn);
 
@@ -14096,7 +15815,7 @@
 
 		if (mdi_prop_update_string(*pip, MDI_GUID,
 		    guid) != DDI_SUCCESS) {
-			mptsas_log(mpt, CE_WARN, "mptsas driver unable to "
+			mptsas_log(mpt, CE_WARN, "unable to "
 			    "create prop for target %d lun %d (MDI_GUID)",
 			    target, lun);
 			mdi_rtn = MDI_FAILURE;
@@ -14105,7 +15824,7 @@
 
 		if (mdi_prop_update_int(*pip, LUN_PROP,
 		    lun) != DDI_SUCCESS) {
-			mptsas_log(mpt, CE_WARN, "mptsas driver unable to "
+			mptsas_log(mpt, CE_WARN, "unable to "
 			    "create prop for target %d lun %d (LUN_PROP)",
 			    target, lun);
 			mdi_rtn = MDI_FAILURE;
@@ -14114,7 +15833,7 @@
 		lun64 = (int64_t)lun;
 		if (mdi_prop_update_int64(*pip, LUN64_PROP,
 		    lun64) != DDI_SUCCESS) {
-			mptsas_log(mpt, CE_WARN, "mptsas driver unable to "
+			mptsas_log(mpt, CE_WARN, "unable to "
 			    "create prop for target %d (LUN64_PROP)",
 			    target);
 			mdi_rtn = MDI_FAILURE;
